/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.cortesias;

import com.rjconsultores.ventaboletos.entidad.GrupoCortesia;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderGrupoCortesias;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Shiro
 */
@Controller("busquedaGrupoCortesiasController")
@Scope("prototype")
public class BusquedaGrupoCortesiasController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<GrupoCortesia> plwGrupoCortesias;
    private MyListbox grupoCortesiaList;
    private Paging pagingGrupoCortesia;
    private Textbox txtNombre;

    public Textbox getTxtNombre() {
        return txtNombre;
    }

    public void setTxtNombre(Textbox txtNombre) {
        this.txtNombre = txtNombre;
    }

    public MyListbox getGrupoCortesiaList() {
        return grupoCortesiaList;
    }

    public void setGrupoCortesiaList(MyListbox grupoCortesiaList) {
        this.grupoCortesiaList = grupoCortesiaList;
    }

    public Paging getPagingGrupoCortesia() {
        return pagingGrupoCortesia;
    }

    public void setPagingGrupoCortesia(Paging pagingGrupoCortesia) {
        this.pagingGrupoCortesia = pagingGrupoCortesia;
    }

    public PagedListWrapper<GrupoCortesia> getPlwGrupoCortesias() {
        return plwGrupoCortesias;
    }

    public void setPlwGrupoCortesias(PagedListWrapper<GrupoCortesia> plwGrupoCortesias) {
        this.plwGrupoCortesias = plwGrupoCortesias;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verGrupoCortesia(new GrupoCortesia());

    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        grupoCortesiaList.setItemRenderer(new RenderGrupoCortesias());
        grupoCortesiaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                GrupoCortesia gc = (GrupoCortesia) grupoCortesiaList.getSelected();
                verGrupoCortesia(gc);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verGrupoCortesia(GrupoCortesia gc) {
        if (gc == null) {
            return;
        }

        Map args = new HashMap();
        args.put("grupoCortesia", gc);
        args.put("grupoCortesiaList", grupoCortesiaList);

        openWindow("/gui/cortesias/editarGrupoCortesias.zul",
                Labels.getLabel("editarGrupoCortesiasController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<GrupoCortesia> claseServicioBusqueda =
                new HibernateSearchObject<GrupoCortesia>(GrupoCortesia.class, pagingGrupoCortesia.getPageSize());

        claseServicioBusqueda.addFilterLike("descgrupo", "%" + txtNombre.getText().trim().concat("%"));
        claseServicioBusqueda.addSortAsc("descgrupo");
        claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);


        plwGrupoCortesias.init(claseServicioBusqueda, grupoCortesiaList, pagingGrupoCortesia);

        if (grupoCortesiaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaGrupoCortesiasController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
